﻿/*
// Exepack.NET compressor
// http://www.codeplex.com/exepack
//
// Tool button attribute
// Written by Y [14-02-09]
// Copyright (c) 2008-2010 Alexey Yakovlev
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Exepack
{
	/// <summary>
	/// Associates method with a toobar button
	/// Method should match EventHandler delegate signature
	/// </summary>
	[AttributeUsage(AttributeTargets.Method, AllowMultiple = false, Inherited = false)]
	internal class ToolButtonAttribute : Attribute
	{
		private ToolButtonAttribute()
		{
			Name = null;
			Hint = null;
			Image = null;
		}

		public ToolButtonAttribute(string name)
		{
			Name = Hint = name;
		}

		public string Name { get; set; }

		public string Hint { get; set; }

		public string Image { get; set; }
	}
}
